﻿var xmlhttpRenew = createAjaxObj();  //在线更新信息xmlhttp对象
var xmlhttpSend = createAjaxObj(); //发送信息xmlhttp对象



var xmls = new Array(2);      //将XmlHttp对象打包至数组
xmls[0] = xmlhttpSend;
xmls[1] = xmlhttpRenew;


var lastMsgID = 0;            //最近聊天信息更新标记
var userListRenewTime = 0;    //最近用户列表更新时间
var userID = "0";             //当前用户ID
var userName = "";            //当前用户名
var userCount = "1";          //当前在线用户数目
var userListArray = new Array()   //当前用户列表数组
var isRev = true;                 //是否是接收信息状态
var lines = 0;            //当前聊天窗口信息条数


function createAjaxObj() {       //XMLhttpRequest 对象创建函数
    var xmlhttp;
    if (window.XMLHttpRequest) {
        //如果为 Mozilla，Safari 等浏览器
        xmlhttp = new XMLHttpRequest();
        if (xmlhttp.overrideMimeType)
            xmlhttp.overrideMimeType('text/xml');
    }
    else if (window.ActiveXObject) {    //如果是Ie浏览器
        try {
            xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
        }
        catch (e) {
            try {
                xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
            }
            catch (e) { }
        }

    }
    return xmlhttp;
}

function startUp() {    //启动函数  
    initialize();                        //用户登陆初始化函数          
    setInterval("onlineRenew()", 1000);      //启动在线信息更新
    document.getElementById("tbSendMessage").focus();
}

function initialize() {      //用户登陆初始化方法    
    systemMessageShow("正在登陆中...", false);
    userName = document.getElementById("lbUserName").innerText;
    var username = escape(userName);
    var url = "ServerPage.aspx?serverType=userlogin" + "&userName=" + username;
    SendCenter(0, url);    //发送XmlHttp连接请求  

}

function onlineRenew() {     //在线信息更新函数         
    var url = "ServerPage.aspx?serverType=onlinerenew&userID=" + userID + "&lastMsgID=" + lastMsgID + "&userListRenewTime=" + userListRenewTime;
    SendCenter(1, url);      //发送XmlHttp连接请求
}

function sendMessage() {     //信息发送函数
    var tbSendMessage = document.getElementById("tbSendMessage");
    var msg = tbSendMessage.value;
    if (msg == "") {
        emptyErrorShow("您不能发送空消息...");
        return;
    }
    else {
        emptyErrorShow("");
    }
    isRev = false;
    var username = escape(userName);
    msg = escape(msg);
    url = "ServerPage.aspx?serverType=messagesend" + "&userID=" + userID + "&lastMsgID=" + lastMsgID + "&userName=" + username + "&userMessage=" + msg + "&userListRenewTime=" + userListRenewTime;
    tbSendMessage.value = "";
    SendCenter(0, url);    //发送XmlHttp连接请求

}

function send() {
    var number = Math.random() * 1000;
    var url = "ServerPage.aspx?num=" + number;
    xmlhttpRenew.open("GET", url, false);
    xmlhttpRenew.send();
    var msg = xmlhttpRenew.responseText;
    alert(msg);

}

function SendCenter(xmlIndex, url) {     //信息发送中心
    if (xmls[xmlIndex].readyState == 4 || xmls[xmlIndex].readyState == 0) {
        var number = Math.random() * 1000;
        url = addUrlArg(url, "ran", number);
        xmls[xmlIndex].open("GET", url, true);
        var handle = new changeHandle(xmlIndex);
        xmls[xmlIndex].onreadystatechange = handle.Listen;
        xmls[xmlIndex].send();
    }
}

function changeHandle(i) {     //xmlhttp 返回信息接收函数
    var index = i;
    this.Listen = function gg() {
        if (xmls[index].readyState == 4 && xmls[index].status == 200) {
            var xmldoc = xmls[index].responseXML;
            var restext = xmls[index].responseText;
            /*if(xmldoc.documentElement ==null){
            var tbChatMessage=document.getElementById("tbChatMessage");
            tbChatMessage.value+="发生错误~\n"+restext+"\n";
            // return;
            } */
            messageManageCenter(restext);        //提交到客户端信息处理中心                    
        }
    }
}

function showMessage(msg) {
    var tbChatMessage = document.getElementById("tbChatMessage");
    tbChatMessage.value += msg;
}

function messageManageCenter(text) {       //客户端信息处理中心   
    //var xmldoc=new ActiveXObject("Microsoft.XMLDOM");
    //xmldoc.loadXML(text);
    var xmldoc = $.parseXML(text);
    setUserName(xmldoc);                   //设置完整用户名
    renewUserList(xmldoc);                 //更新用户列表     
    renewChatMessage(xmldoc);              //更新聊天信息
}

function renewChatMessage(xmldoc) {          //更新聊天信息函数
    var chatMessage = xmldoc.getElementsByTagName("chatMessageList")[0];
    if (chatMessage != null) {
        var count = chatMessage.getAttribute("count");
        var cbshowall = document.getElementById("cbShowAllMsg");
        userId = xmldoc.documentElement.getAttribute("userID");
        var childs = chatMessage.getElementsByTagName("message");
        if (childs.length == 0) {
            return;
        }
        lastMsgID = count;
        var str = "";
        var tbChatMessage = document.getElementById("tbChatMessage");
        if (!cbshowall.checked && lines >= 8) {
            tbChatMessage.value = "";
            lines = 0;
        }
        for (var i = 0; i < childs.length; i++) {
            str += childs[i].childNodes[0].nodeValue + "\n";
            lines++;
        }
        str = unescape(str);
        tbChatMessage.value += str;
        if (isRev) {
            playSound("message");
        }
        isRev = true;
    }
}

function renewUserList(xmldoc) {     //更新用户列表函数
    var userList = xmldoc.getElementsByTagName("userList")[0];
    if (userList != null) {
        userListRenewTime = userList.getAttribute("listRenewTime");  //更新用户列表更新时间        
        userCount = userList.getAttribute("count");
        listBoxClear("ListBox1");                              //清除原用户列表
        var lbuserCount = document.getElementById("label3");
        var $lbuserCount = $(lbuserCount);    //更新为使用jQuery 对象  
        $lbuserCount.html("当前在线用户" + userCount + "人");
        var newuserList = new Array();
        var childs = userList.childNodes;
        for (var i = 0; i < childs.length; i++) {
            var name = childs[i].getAttribute("name");
            var id = childs[i].getAttribute("id");
            var username = "(" + id + ") " + name;
            newuserList[newuserList.length] = username;
            addListBoxItem("ListBox1", username, id);
        }
        userListManage(newuserList);                        //用户列表更新管理        
    }
}

function userListManage(newUserList) {                       //用户列表更新管理函数
    if (userListArray.length != 0) {
        var onlineUserArray = getOutUser(newUserList, userListArray);
        var offlineUserArray = getOutUser(userListArray, newUserList);
        systemMessageManage(onlineUserArray, true);
        systemMessageManage(offlineUserArray, false);
    }
    userListArray = newUserList;
}

function systemMessageManage(userlist, online) {      //系统消息处理函数  
    if (online) {
        systemMessageShow("", true);
    }
    var msg = (online ? "上线了" : "下线了")
    for (var i = 0; i < userlist.length; i++) {
        var str = userlist[i] + " " + msg
        systemMessageShow(str, false);
        if (online) {
            playSound("global");
        }
        else {
            playSound("system");
        }
    }
}

function getOutUser(resArray, objArray) {     //获取多出用户
    var objStr = "";
    var ret = new Array();
    for (var i = 0; i < objArray.length; i++)
        objStr += objArray[i];
    for (var i = 0; i < resArray.length; i++) {
        if (objStr.indexOf(resArray[i]) == -1) {
            ret[ret.length] = resArray[i];
        }
    }
    return ret;
}

function playSound(id) {        //声音播放函数  
    document.getElementById(id).play();
}



function setUserName(xmldoc) {     //设置完整用户名
    if (userID.length == 5) {
        return;
    }
    var root = xmldoc.documentElement;
    if (root != null) {
        userID = root.getAttribute("userID");
        lbusername = document.getElementById("lbUserName");
        lbusername.innerText = userName + "(" + userID + ")";
        systemMessageShow("登陆成功...", false);
    }
}

function addUrlArg(url, name, value) {     //Url参数累加函数
    var connect = (url.indexOf("?") == -1) ? "?" : "&";
    url = url + connect + name + "=" + value;
    return url;
}

function emptyErrorShow(msg) {  //发送空信息警告
    var lbEmptyError = document.getElementById("lbEmptyError");
    lbEmptyError.innerText = msg;
}

function addListBoxItem(f, t, v) {  //用户列表项目添加函数
    var sel = document.getElementById(f);
    var opt = new Option(t, v, false, false);
    sel.options[sel.length] = opt;
}

function listBoxClear(id) {       //列表框清空函数  
    var obj = document.getElementById(id);
    while (obj.length != 0) {
        obj.options[0] = null;
    }
}

function showManager() {     //聊天信息管理
    var cbshowall = document.getElementById("cbShowAllMsg");
    if (cbshowall.checked) {
        var url = "ServerPage.aspx?serverType=onlinerenew&userID=" + userID + "&lastMsgID=0" + "&userListRenewTime=" + userListRenewTime;
        isRev = false;
        SendCenter(0, url);      //发送XmlHttp连接请求        
    }
}

function systemMessageShow(msg, clear) {    //系统消息显示函数
    var tbSystemMessage = document.getElementById("tbSystemMessage");
    if (clear) {
        tbSystemMessage.value = "";
    }
    if (msg == "") {
        return;
    }
    var now = new Date();
    var time = now.getHours() + ":" + now.getMinutes() + ":" + now.getSeconds();
    msg = msg + "\n" + time + "\n";
    tbSystemMessage.value += msg;
}